diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-tx-timer.h ns-3.34/src/wifi/model/wifi-tx-timer.h
--- ns-3.33/src/wifi/model/wifi-tx-timer.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-tx-timer.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,267 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef WIFI_TX_TIMER_H
+#define WIFI_TX_TIMER_H
+
+#include "ns3/event-id.h"
+#include "ns3/nstime.h"
+#include "ns3/simulator.h"
+#include "ns3/traced-callback.h"
+#include <functional>
+#include <unordered_map>
+
+namespace ns3 {
+
+class WifiMacQueueItem;
+class WifiPsdu;
+class WifiTxVector;
+class Mac48Address;
+
+typedef std::unordered_map <uint16_t /* staId */, Ptr<WifiPsdu> /* PSDU */> WifiPsduMap;
+
+/**
+ * \ingroup wifi
+ *
+ * This class is used to handle the timer that a station starts when transmitting
+ * a frame that solicits a response. The timeout can be rescheduled (only once)
+ * when the RXSTART.indication is received from the PHY.
+ */
+class WifiTxTimer
+{
+public:
+  /**
+   * \enum Reason
+   * \brief The reason why the timer was started
+   */
+  enum Reason : uint8_t
+    {
+      NOT_RUNNING = 0,
+      WAIT_CTS,
+      WAIT_NORMAL_ACK,
+      WAIT_BLOCK_ACK,
+      WAIT_NORMAL_ACK_AFTER_DL_MU_PPDU,
+      WAIT_BLOCK_ACKS_IN_TB_PPDU,
+      WAIT_TB_PPDU_AFTER_BASIC_TF,
+      WAIT_QOS_NULL_AFTER_BSRP_TF,
+      WAIT_BLOCK_ACK_AFTER_TB_PPDU,
+    };
+
+  /** Default constructor */
+  WifiTxTimer ();
+
+  virtual ~WifiTxTimer ();
+
+  /**
+   * This method is called when a frame soliciting a response is transmitted.
+   * This method starts a timer of the given duration and schedules a call to
+   * the given method in case the timer expires.
+   *
+   * \tparam MEM \deduced Class method function signature type
+   * \tparam OBJ \deduced Class type of the object
+   * \tparam Args \deduced Type template parameter pack
+   * \param reason the reason why the timer was started
+   * \param delay the time to the expiration of the timer
+   * \param mem_ptr Member method pointer to invoke
+   * \param obj The object on which to invoke the member method
+   * \param args The arguments to pass to the invoked method
+   */
+  template<typename MEM, typename OBJ, typename... Args>
+  void Set (Reason reason, const Time &delay, MEM mem_ptr, OBJ obj, Args... args);
+
+  /**
+   * Reschedule the timer to time out the given amount of time from the moment
+   * this function is called. Note that the timer must be running and must not
+   * have been already rescheduled.
+   *
+   * \param delay the time to the expiration of the timer
+   */
+  void Reschedule (const Time &delay);
+
+  /**
+   * Get the reason why the timer was started. Call
+   * this method only if the timer is running
+   *
+   * \return the reason why the timer was started
+   */
+  Reason GetReason (void) const;
+
+  /**
+   * Get a string associated with the given reason
+   *
+   * \param reason the given reason
+   * \return a string associated with the given reason
+   */
+  std::string GetReasonString (Reason reason) const;
+
+  /**
+   * Return true if the timer is running
+   *
+   * \return true if the timer is running
+   */
+  bool IsRunning (void) const;
+
+  /**
+   * Cancel the timer.
+   */
+  void Cancel (void);
+
+  /**
+   * Get the remaining time until the timer will expire.
+   *
+   * \return the remaining time until the timer will expire.
+   *         If the timer is not running, this method returns zero.
+   */
+  Time GetDelayLeft (void) const;
+
+  /**
+   * MPDU response timeout callback typedef
+   */
+  typedef Callback<void, uint8_t, Ptr<const WifiMacQueueItem>, const WifiTxVector&> MpduResponseTimeout;
+
+  /**
+   * PSDU response timeout callback typedef
+   */
+  typedef Callback<void, uint8_t, Ptr<const WifiPsdu>, const WifiTxVector&> PsduResponseTimeout;
+
+  /**
+   * PSDU map response timeout callback typedef
+   */
+  typedef Callback<void, uint8_t, WifiPsduMap*, const std::set<Mac48Address>*, std::size_t> PsduMapResponseTimeout;
+
+  /**
+   * Set the callback to invoke when the TX timer following the transmission of an MPDU expires.
+   *
+   * \param callback the callback to invoke when the TX timer following the transmission
+   *                 of an MPDU expires
+   */
+  void SetMpduResponseTimeoutCallback (MpduResponseTimeout callback) const;
+
+  /**
+   * Set the callback to invoke when the TX timer following the transmission of a PSDU expires.
+   *
+   * \param callback the callback to invoke when the TX timer following the transmission
+   *                 of a PSDU expires
+   */
+  void SetPsduResponseTimeoutCallback (PsduResponseTimeout callback) const;
+
+  /**
+   * Set the callback to invoke when the TX timer following the transmission of a PSDU map expires.
+   *
+   * \param callback the callback to invoke when the TX timer following the transmission
+   *                 of a PSDU map expires
+   */
+  void SetPsduMapResponseTimeoutCallback (PsduMapResponseTimeout callback) const;
+
+private:
+  /**
+   * This method is called when the timer expires. It invokes the callbacks
+   * and the method set by the user.
+   *
+   * \tparam MEM \deduced Class method function signature type
+   * \tparam OBJ \deduced Class type of the object
+   * \tparam Args \deduced Type template parameter pack
+   * \param mem_ptr Member method pointer to invoke
+   * \param obj The object on which to invoke the member method
+   * \param args The arguments to pass to the invoked method
+   */
+  template<typename MEM, typename OBJ, typename... Args>
+  void Timeout (MEM mem_ptr, OBJ obj, Args... args);
+
+  /**
+   * This method is called when the timer expires to feed the MPDU response
+   * timeout callback.
+   *
+   * \param item the MPDU followed by no response
+   * \param txVector the TXVECTOR used to transmit the MPDU
+   */
+  void FeedTraceSource (Ptr<WifiMacQueueItem> item, WifiTxVector txVector);
+
+  /**
+   * This method is called when the timer expires to feed the PSDU response
+   * timeout callback.
+   *
+   * \param psdu the PSDU followed by no response
+   * \param txVector the TXVECTOR used to transmit the PSDU
+   */
+  void FeedTraceSource (Ptr<WifiPsdu> psdu, WifiTxVector txVector);
+
+  /**
+   * This method is called when the timer expires to feed the PSDU map response
+   * timeout callback.
+   *
+   * \param psduMap the PSDU map for which not all responses were received
+   * \param missingStations the set of stations that did not respond
+   * \param nTotalStations the total number of expected responses
+   */
+  void FeedTraceSource (WifiPsduMap* psduMap, std::set<Mac48Address>* missingStations,
+                        std::size_t nTotalStations);
+
+  EventId m_timeoutEvent;         //!< the timeout event after a missing response
+  Reason m_reason;                //!< the reason why the timer was started
+  Ptr<EventImpl> m_endRxEvent;       //!< event to schedule upon RXSTART.indication
+  bool m_rescheduled;             //!< whether the timer has been already rescheduled
+
+  /// the MPDU response timeout callback
+  mutable MpduResponseTimeout m_mpduResponseTimeoutCallback;
+  /// the PSDU response timeout callback
+  mutable PsduResponseTimeout m_psduResponseTimeoutCallback;
+  /// the PSDU map response timeout callback
+  mutable PsduMapResponseTimeout m_psduMapResponseTimeoutCallback;
+};
+
+} // namespace ns3
+
+
+/***************************************************************
+ *  Implementation of the templates declared above.
+ ***************************************************************/
+
+namespace ns3 {
+
+template<typename MEM, typename OBJ, typename... Args>
+void
+WifiTxTimer::Set (Reason reason, const Time &delay, MEM mem_ptr, OBJ obj, Args... args)
+{
+  typedef void (WifiTxTimer::*TimeoutType)(MEM, OBJ, Args...);
+
+  m_timeoutEvent = Simulator::Schedule<TimeoutType> (delay, &WifiTxTimer::Timeout, this, mem_ptr, obj, args...);
+  m_reason = reason;
+  m_rescheduled = false;
+
+  // create an event to schedule if the PHY notifies the reception of a response
+  m_endRxEvent = Ptr<EventImpl> (MakeEvent<TimeoutType> (&WifiTxTimer::Timeout, this, mem_ptr, obj,
+                                                      std::forward<Args> (args)... ), false);
+}
+
+template<typename MEM, typename OBJ, typename... Args>
+void
+WifiTxTimer::Timeout (MEM mem_ptr, OBJ obj, Args... args)
+{
+  FeedTraceSource (std::forward<Args> (args)...);
+
+  // Invoke the method set by the user
+  ((*obj).*mem_ptr)(std::forward<Args> (args)...);
+}
+
+} //namespace ns3
+
+#endif /* WIFI_TX_TIMER_H */
+
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-tx-vector.cc ns-3.34/src/wifi/model/wifi-tx-vector.cc
--- ns-3.33/src/wifi/model/wifi-tx-vector.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-tx-vector.cc	2021-07-14 10:31:07.000000000 -0700
@@ -35,6 +35,7 @@
     m_stbc (false),
     m_ldpc (false),
     m_bssColor (0),
+    m_length (0),
     m_modeInitialized (false)
 {
 }
@@ -50,7 +51,8 @@
                             bool aggregation,
                             bool stbc,
                             bool ldpc,
-                            uint8_t bssColor)
+                            uint8_t bssColor,
+                            uint16_t length)
   : m_mode (mode),
     m_txPowerLevel (powerLevel),
     m_preamble (preamble),
@@ -63,6 +65,7 @@
     m_stbc (stbc),
     m_ldpc (ldpc),
     m_bssColor (bssColor),
+    m_length (length),
     m_modeInitialized (true)
 {
 }
@@ -80,6 +83,7 @@
     m_stbc (txVector.m_stbc),
     m_ldpc (txVector.m_ldpc),
     m_bssColor (txVector.m_bssColor),
+    m_length (txVector.m_length),
     m_modeInitialized (txVector.m_modeInitialized)
 {
   m_muUserInfos.clear ();
@@ -110,7 +114,7 @@
     {
       NS_FATAL_ERROR ("WifiTxVector mode must be set before using");
     }
-  if (m_preamble == WIFI_PREAMBLE_HE_MU || m_preamble == WIFI_PREAMBLE_HE_TB)
+  if (IsMu ())
     {
       NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU (" << staId << ")");
       NS_ASSERT (m_muUserInfos.find (staId) != m_muUserInfos.end ());
@@ -119,6 +123,20 @@
   return m_mode;
 }
 
+WifiModulationClass
+WifiTxVector::GetModulationClass (void) const
+{
+  NS_ABORT_MSG_IF (!m_modeInitialized, "WifiTxVector mode must be set before using");
+
+  if (IsMu ())
+    {
+      NS_ASSERT (!m_muUserInfos.empty ());
+      // all the modes belong to the same modulation class
+      return m_muUserInfos.begin ()->second.mcs.GetModulationClass ();
+    }
+  return m_mode.GetModulationClass ();
+}
+
 uint8_t
 WifiTxVector::GetTxPowerLevel (void) const
 {
@@ -152,7 +170,7 @@
 uint8_t
 WifiTxVector::GetNss (uint16_t staId) const
 {
-  if (m_preamble == WIFI_PREAMBLE_HE_MU || m_preamble == WIFI_PREAMBLE_HE_TB)
+  if (IsMu ())
     {
       NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU (" << staId << ")");
       NS_ASSERT (m_muUserInfos.find (staId) != m_muUserInfos.end ());
@@ -165,7 +183,7 @@
 WifiTxVector::GetNssMax (void) const
 {
   uint8_t nss = 0;
-  if (m_preamble == WIFI_PREAMBLE_HE_MU || m_preamble == WIFI_PREAMBLE_HE_TB)
+  if (IsMu ())
     {
       for (const auto & info : m_muUserInfos)
         {
@@ -213,7 +231,7 @@
 void
 WifiTxVector::SetMode (WifiMode mode, uint16_t staId)
 {
-  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "Not an HE MU transmission");
+  NS_ABORT_MSG_IF (!IsMu (), "Not an HE MU transmission");
   NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
   m_muUserInfos[staId].mcs = mode;
   m_modeInitialized = true;
@@ -258,7 +276,7 @@
 void
 WifiTxVector::SetNss (uint8_t nss, uint16_t staId)
 {
-  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "Not an HE MU transmission");
+  NS_ABORT_MSG_IF (!IsMu (), "Not an HE MU transmission");
   NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
   m_muUserInfos[staId].nss = nss;
 }
@@ -299,6 +317,18 @@
   return m_bssColor;
 }
 
+void
+WifiTxVector::SetLength (uint16_t length)
+{
+  m_length = length;
+}
+
+uint16_t
+WifiTxVector::GetLength (void) const
+{
+  return m_length;
+}
+
 bool
 WifiTxVector::IsValid (void) const
 {
@@ -335,10 +365,28 @@
   return true;
 }
 
+bool
+WifiTxVector::IsMu (void) const
+{
+  return (m_preamble == WIFI_PREAMBLE_HE_MU || m_preamble == WIFI_PREAMBLE_HE_TB);
+}
+
+bool
+WifiTxVector::IsDlMu (void) const
+{
+  return ((m_preamble == WIFI_PREAMBLE_VHT_MU) || (m_preamble == WIFI_PREAMBLE_HE_MU));
+}
+
+bool
+WifiTxVector::IsUlMu (void) const
+{
+  return (m_preamble == WIFI_PREAMBLE_HE_TB);
+}
+
 HeRu::RuSpec
 WifiTxVector::GetRu (uint16_t staId) const
 {
-  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "RU only available for MU");
+  NS_ABORT_MSG_IF (!IsMu (), "RU only available for MU");
   NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
   return m_muUserInfos.at (staId).ru;
 }
@@ -346,7 +394,7 @@
 void
 WifiTxVector::SetRu (HeRu::RuSpec ru, uint16_t staId)
 {
-  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "RU only available for MU");
+  NS_ABORT_MSG_IF (!IsMu (), "RU only available for MU");
   NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
   m_muUserInfos[staId].ru = ru;
 }
@@ -354,14 +402,14 @@
 HeMuUserInfo
 WifiTxVector::GetHeMuUserInfo (uint16_t staId) const
 {
-  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "HE MU user info only available for MU");
+  NS_ABORT_MSG_IF (!IsMu (), "HE MU user info only available for MU");
   return m_muUserInfos.at (staId);
 }
 
 void
 WifiTxVector::SetHeMuUserInfo (uint16_t staId, HeMuUserInfo userInfo)
 {
-  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "HE MU user info only available for MU");
+  NS_ABORT_MSG_IF (!IsMu (), "HE MU user info only available for MU");
   NS_ABORT_MSG_IF (staId > 2048, "STA-ID should be correctly set for HE MU");
   NS_ABORT_MSG_IF (userInfo.mcs.GetModulationClass () != WIFI_MOD_CLASS_HE, "Only HE modes authorized for HE MU");
   m_muUserInfos[staId] = userInfo;
@@ -371,10 +419,85 @@
 const WifiTxVector::HeMuUserInfoMap&
 WifiTxVector::GetHeMuUserInfoMap (void) const
 {
-  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "HE MU user info map only available for MU");
+  NS_ABORT_MSG_IF (!IsMu (), "HE MU user info map only available for MU");
   return m_muUserInfos;
 }
 
+WifiTxVector::HeMuUserInfoMap&
+WifiTxVector::GetHeMuUserInfoMap (void)
+{
+  NS_ABORT_MSG_IF (!IsMu (), "HE MU user info map only available for MU");
+  return m_muUserInfos;
+}
+
+std::pair<std::size_t, std::size_t>
+WifiTxVector::GetNumRusPerHeSigBContentChannel (void) const
+{
+  NS_ABORT_MSG_IF (m_preamble != WIFI_PREAMBLE_HE_MU, "HE-SIG-B content channels only available for HE MU");
+  //MU-MIMO is not handled for now, i.e. one station per RU
+
+  if (m_channelWidth == 20)
+    {
+      return std::make_pair (m_muUserInfos.size (), 0); //all RUs are in HE-SIG-B content channel 1
+    }
+
+  HeRu::SubcarrierGroup toneRangesContentChannel1, toneRangesContentChannel2;
+  // See section 27.3.10.8.3 of IEEE 802.11ax draft 4.0 for tone ranges per HE-SIG-B content channel
+  switch (m_channelWidth)
+    {
+      case 40:
+        toneRangesContentChannel1.push_back (std::make_pair (-244, -3));
+        toneRangesContentChannel2.push_back (std::make_pair (3, 244));
+        break;
+      case 80:
+        toneRangesContentChannel1.push_back (std::make_pair (-500, -259));
+        toneRangesContentChannel2.push_back (std::make_pair (-258, -17));
+        toneRangesContentChannel1.push_back (std::make_pair (-16, -4)); //first part of center carrier (in HE-SIG-B content channel 1)
+        toneRangesContentChannel1.push_back (std::make_pair (4, 16)); //second part of center carrier (in HE-SIG-B content channel 1)
+        toneRangesContentChannel1.push_back (std::make_pair (17, 258));
+        toneRangesContentChannel2.push_back (std::make_pair (259, 500));
+        break;
+      case 160:
+        toneRangesContentChannel1.push_back (std::make_pair (-1012, -771));
+        toneRangesContentChannel2.push_back (std::make_pair (-770, -529));
+        toneRangesContentChannel1.push_back (std::make_pair (-528, -516)); //first part of center carrier of lower 80 MHz band (in HE-SIG-B content channel 1)
+        toneRangesContentChannel1.push_back (std::make_pair (-508, -496)); //second part of center carrier of lower 80 MHz band (in HE-SIG-B content channel 1)
+        toneRangesContentChannel1.push_back (std::make_pair (-495, -254));
+        toneRangesContentChannel2.push_back (std::make_pair (-253, -12));
+        toneRangesContentChannel1.push_back (std::make_pair (12, 253));
+        toneRangesContentChannel2.push_back (std::make_pair (254, 495));
+        toneRangesContentChannel2.push_back (std::make_pair (496, 508)); //first part of center carrier of upper 80 MHz band (in HE-SIG-B content channel 2)
+        toneRangesContentChannel2.push_back (std::make_pair (516, 528)); //second part of center carrier of upper 80 MHz band (in HE-SIG-B content channel 2)
+        toneRangesContentChannel1.push_back (std::make_pair (529, 770));
+        toneRangesContentChannel2.push_back (std::make_pair (771, 1012));
+        break;
+      default:
+        NS_ABORT_MSG ("Unknown channel width: " << m_channelWidth);
+    }
+
+  std::size_t numRusContentChannel1 = 0;
+  std::size_t numRusContentChannel2 = 0;
+  for (auto & userInfo : m_muUserInfos)
+    {
+      HeRu::RuSpec ru = userInfo.second.ru;
+      if (!ru.IsPhyIndexSet ())
+        {
+          // this method can be called when calculating the TX duration of a frame
+          // and at that time the RU PHY index may have not been set yet
+          ru.SetPhyIndex (m_channelWidth, 0);
+        }
+      if (HeRu::DoesOverlap (m_channelWidth, ru, toneRangesContentChannel1))
+        {
+          numRusContentChannel1++;
+        }
+      if (HeRu::DoesOverlap (m_channelWidth, ru, toneRangesContentChannel2))
+        {
+          numRusContentChannel2++;
+        }
+    }
+  return std::make_pair (numRusContentChannel1, numRusContentChannel2);
+}
+
 std::ostream & operator << ( std::ostream &os, const WifiTxVector &v)
 {
   if (!v.IsValid ())
@@ -391,7 +514,15 @@
      << " MPDU aggregation: " << v.IsAggregation ()
      << " STBC: " << v.IsStbc ()
      << " FEC coding: " << (v.IsLdpc () ? "LDPC" : "BCC");
-  if (v.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
+  if (v.GetPreambleType () >= WIFI_PREAMBLE_HE_SU)
+    {
+      os << " BSS color: " << +v.GetBssColor ();
+    }
+  if (v.GetPreambleType () == WIFI_PREAMBLE_HE_TB)
+    {
+      os << " Length: " << v.GetLength ();
+    }
+  if (v.IsMu ())
     {
       WifiTxVector::HeMuUserInfoMap userInfoMap = v.GetHeMuUserInfoMap ();
       os << " num User Infos: " << userInfoMap.size ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-tx-vector.h ns-3.34/src/wifi/model/wifi-tx-vector.h
--- ns-3.33/src/wifi/model/wifi-tx-vector.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-tx-vector.h	2021-07-14 10:31:07.000000000 -0700
@@ -24,8 +24,8 @@
 
 #include <list>
 #include "wifi-mode.h"
-#include "wifi-preamble.h"
-#include "he-ru.h"
+#include "wifi-phy-common.h"
+#include "ns3/he-ru.h"
 
 namespace ns3 {
 
@@ -90,6 +90,7 @@
    * \param stbc enable or disable STBC
    * \param ldpc enable or disable LDPC (BCC is used otherwise)
    * \param bssColor the BSS color
+   * \param length the LENGTH field of the L-SIG
    */
   WifiTxVector (WifiMode mode,
                 uint8_t powerLevel,
@@ -102,7 +103,8 @@
                 bool aggregation,
                 bool stbc = false,
                 bool ldpc = false,
-                uint8_t bssColor = 0);
+                uint8_t bssColor = 0,
+                uint16_t length = 0);
   /**
    * Copy constructor
    * \param txVector the TXVECTOR to copy
@@ -138,6 +140,13 @@
   void SetMode (WifiMode mode, uint16_t staId);
 
   /**
+   * Get the modulation class specified by this TXVECTOR.
+   *
+   * \return the Modulation Class specified by this TXVECTOR
+   */
+  WifiModulationClass GetModulationClass (void) const;
+
+  /**
    * \returns the transmission power level
    */
   uint8_t GetTxPowerLevel (void) const;
@@ -273,6 +282,16 @@
    */
   uint8_t GetBssColor (void) const;
   /**
+   * Set the LENGTH field of the L-SIG
+   * \param length the LENGTH field of the L-SIG
+   */
+  void SetLength (uint16_t length);
+  /**
+   * Get the LENGTH field of the L-SIG
+   * \return the LENGTH field of the L-SIG
+   */
+  uint16_t GetLength (void) const;
+  /**
    * The standard disallows certain combinations of WifiMode, number of
    * spatial streams, and channel widths.  This method can be used to
    * check whether this WifiTxVector contains an invalid combination.
@@ -281,6 +300,24 @@
    */
   bool IsValid (void) const;
    /**
+   * Return true if this TX vector is used for a multi-user transmission.
+   *
+   * \return true if this TX vector is used for a multi-user transmission
+   */
+  bool IsMu (void) const;
+   /**
+   * Return true if this TX vector is used for a downlink multi-user transmission.
+   *
+   * \return true if this TX vector is used for a downlink multi-user transmission
+   */
+  bool IsDlMu (void) const;
+   /**
+   * Return true if this TX vector is used for an uplink multi-user transmission.
+   *
+   * \return true if this TX vector is used for an uplink multi-user transmission
+   */
+  bool IsUlMu (void) const;
+  /**
     * Get the RU specification for the STA-ID.
     * This is applicable only for HE MU.
     *
@@ -313,12 +350,28 @@
     */
    void SetHeMuUserInfo (uint16_t staId, HeMuUserInfo userInfo);
    /**
-    * Get the map HE MU user-specific transmission information indexed by STA-ID.
+    * Get a const reference to the map HE MU user-specific transmission information indexed by STA-ID.
     * This is applicable only for HE MU.
     *
-    * \return the map of HE MU user-specific information indexed by STA-ID
+    * \return a const reference to the map of HE MU user-specific information indexed by STA-ID
     */
    const HeMuUserInfoMap& GetHeMuUserInfoMap (void) const;
+   /**
+    * Get a reference to the map HE MU user-specific transmission information indexed by STA-ID.
+    * This is applicable only for HE MU.
+    *
+    * \return a reference to the map of HE MU user-specific information indexed by STA-ID
+    */
+   HeMuUserInfoMap& GetHeMuUserInfoMap (void);
+   /**
+    * Get the number of RUs per HE-SIG-B content channel.
+    * This is applicable only for HE MU. MU-MIMO (i.e. multiple stations
+    * per RU) is not supported yet.
+    * See section 27.3.10.8.3 of IEEE 802.11ax draft 4.0.
+    *
+    * \return a pair containing the number of RUs in each HE-SIG-B content channel (resp. 1 and 2)
+    */
+   std::pair<std::size_t, std::size_t> GetNumRusPerHeSigBContentChannel (void) const;
 
 
 private:
@@ -338,6 +391,7 @@
   bool     m_stbc;               /**< STBC used or not */
   bool     m_ldpc;               /**< LDPC FEC coding if true, BCC otherwise*/
   uint8_t  m_bssColor;           /**< BSS color */
+  uint16_t m_length;             /**< LENGTH field of the L-SIG */
 
   bool     m_modeInitialized;         /**< Internal initialization flag */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-utils.cc ns-3.34/src/wifi/model/wifi-utils.cc
--- ns-3.33/src/wifi/model/wifi-utils.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-utils.cc	2021-07-14 10:31:07.000000000 -0700
@@ -24,8 +24,8 @@
 #include "wifi-mac-header.h"
 #include "wifi-mac-trailer.h"
 #include "wifi-net-device.h"
-#include "ht-configuration.h"
-#include "he-configuration.h"
+#include "ns3/ht-configuration.h"
+#include "ns3/he-configuration.h"
 #include "wifi-mode.h"
 #include "ampdu-subframe-header.h"
 
@@ -113,7 +113,7 @@
 }
 
 WifiPreamble
-GetPreambleForTransmission (WifiModulationClass modulation, bool useShortPreamble, bool useGreenfield)
+GetPreambleForTransmission (WifiModulationClass modulation, bool useShortPreamble)
 {
   if (modulation == WIFI_MOD_CLASS_HE)
     {
@@ -123,16 +123,11 @@
     {
       return WIFI_PREAMBLE_VHT_SU;
     }
-  else if (modulation == WIFI_MOD_CLASS_HT && useGreenfield)
-    {
-      //If protection for Greenfield is used we go for HT_MF preamble which is the default protection for GF format defined in the standard.
-      return WIFI_PREAMBLE_HT_GF;
-    }
   else if (modulation == WIFI_MOD_CLASS_HT)
     {
-      return WIFI_PREAMBLE_HT_MF;
+      return WIFI_PREAMBLE_HT_MF; // HT_GF has been removed
     }
-  else if (useShortPreamble)
+  else if (modulation == WIFI_MOD_CLASS_HR_DSSS && useShortPreamble) //ERP_DSSS is modeled through HR_DSSS (since same preamble and modulation)
     {
       return WIFI_PREAMBLE_SHORT;
     }
@@ -184,7 +179,7 @@
 }
 
 uint32_t
-GetBlockAckRequestSize (BlockAckType type)
+GetBlockAckRequestSize (BlockAckReqType type)
 {
   WifiMacHeader hdr;
   hdr.SetType (WIFI_MAC_CTL_BACKREQ);
@@ -194,6 +189,23 @@
 }
 
 uint32_t
+GetMuBarSize (std::list<BlockAckReqType> types)
+{
+  WifiMacHeader hdr;
+  hdr.SetType (WIFI_MAC_CTL_TRIGGER);
+  CtrlTriggerHeader trigger;
+  trigger.SetType (MU_BAR_TRIGGER);
+  for (auto& t : types)
+    {
+      auto userInfo = trigger.AddUserInfoField ();
+      CtrlBAckRequestHeader bar;
+      bar.SetType (t);
+      userInfo.SetMuBarTriggerDepUserInfo (bar);
+    }
+  return hdr.GetSize () + trigger.GetSerializedSize () + 4;
+}
+
+uint32_t
 GetRtsSize (void)
 {
   WifiMacHeader rts;
@@ -245,21 +257,18 @@
 
   switch (preamble)
     {
-    case WIFI_PREAMBLE_HT_GF:
-      duration = MicroSeconds (10000);
-      break;
-    case WIFI_PREAMBLE_HT_MF:
-    case WIFI_PREAMBLE_VHT_SU:
-    case WIFI_PREAMBLE_VHT_MU:
-    case WIFI_PREAMBLE_HE_SU:
-    case WIFI_PREAMBLE_HE_ER_SU:
-    case WIFI_PREAMBLE_HE_MU:
-    case WIFI_PREAMBLE_HE_TB:
-      duration = MicroSeconds (5484);
-      break;
-    default:
-      duration = MicroSeconds (0);
-      break;
+      case WIFI_PREAMBLE_HT_MF:
+      case WIFI_PREAMBLE_VHT_SU:
+      case WIFI_PREAMBLE_VHT_MU:
+      case WIFI_PREAMBLE_HE_SU:
+      case WIFI_PREAMBLE_HE_ER_SU:
+      case WIFI_PREAMBLE_HE_MU:
+      case WIFI_PREAMBLE_HE_TB:
+        duration = MicroSeconds (5484);
+        break;
+      default:
+        duration = MicroSeconds (0);
+        break;
     }
   return duration;
 }
@@ -267,7 +276,7 @@
 bool
 IsHt (WifiPreamble preamble)
 {
-   return (preamble == WIFI_PREAMBLE_HT_MF || preamble == WIFI_PREAMBLE_HT_GF);
+   return (preamble == WIFI_PREAMBLE_HT_MF);
 }
 
 bool
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-utils.h ns-3.34/src/wifi/model/wifi-utils.h
--- ns-3.33/src/wifi/model/wifi-utils.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-utils.h	2021-07-14 10:31:07.000000000 -0700
@@ -22,8 +22,9 @@
 #define WIFI_UTILS_H
 
 #include "block-ack-type.h"
-#include "wifi-preamble.h"
+#include "wifi-phy-common.h"
 #include "wifi-mode.h"
+#include <list>
 
 namespace ns3 {
 
@@ -89,11 +90,10 @@
  *
  * \param modulation the modulation selected for the transmission
  * \param useShortPreamble whether short preamble should be used
- * \param useGreenfield whether HT Greenfield should be used
  *
  * \return the preamble to be used for the transmission
  */
-WifiPreamble GetPreambleForTransmission (WifiModulationClass modulation, bool useShortPreamble, bool useGreenfield);
+WifiPreamble GetPreambleForTransmission (WifiModulationClass modulation, bool useShortPreamble);
 /**
  * Return the channel width that corresponds to the selected mode (instead of
  * letting the PHY's default channel width). This is especially useful when using
@@ -134,7 +134,14 @@
  * \param type the BlockAckRequest type
  * \return the total BlockAckRequest size in bytes
  */
-uint32_t GetBlockAckRequestSize (BlockAckType type);
+uint32_t GetBlockAckRequestSize (BlockAckReqType type);
+/**
+ * Return the total MU-BAR size (including FCS trailer).
+ *
+ * \param types the list of Block Ack Request types of the individual BARs
+ * \return the total MU-BAR size in bytes
+ */
+uint32_t GetMuBarSize (std::list<BlockAckReqType> types);
 /**
  * Return the total RTS size (including FCS trailer).
  *
